﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;

namespace TestView.Controllers
{
    public class TestController : Controller
    {       
        public ActionResult Index()
        {        
            return View();
        }

        public ActionResult GetEmployee([DataSourceRequest]DataSourceRequest request)
        {
            IEnumerable<Employee> lst = Employee.GetAllEmployee();
            return Json(lst.ToDataSourceResult(request), JsonRequestBehavior.AllowGet);
        }
    }

    public class Employee
    {
        public string id { get; set; }
        public bool hasChildren { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public int Level { get; set; }
        public string Manager { get; set; }
        public string Phone { get; set; }
        public string Position { get; set; }
        public bool expanded { get; set; }
        public bool childrenloaded { get; set; }
        public IList<Employee> items { get; set; }
     

        public Employee()
        {
            items = new List<Employee>();
        }

        internal static IEnumerable<Employee> GetAllEmployee()
        {
            return new List<Employee>()
            {   new Employee { id="1",  FirstName="Daryl",      LastName="Sweeney", Manager="",  Phone="(555) 924-9726", Level=1, hasChildren=true,  Position ="CEO"} ,
                new Employee { id="2",  FirstName="Guy",        LastName="Wooten",  Manager="1", Phone="(438) 738-4935", Level=2, hasChildren=true,  Position ="Chief Technical Officer"} ,
                new Employee { id="3",  FirstName="Buffy",      LastName="Weber",   Manager="2", Phone="(699) 838-6121", Level=3, hasChildren=true,  Position ="VP, Engineering"} ,
                new Employee { id="4",  FirstName="Hyacinth",   LastName="Hood",    Manager="3", Phone="(889) 345-2438", Level=4, hasChildren=true,  Position ="Team Lead" } ,
                new Employee { id="5",  FirstName="Akeem",      LastName="Carr",    Manager="4", Phone="(738) 136-2814", Level=5, hasChildren=false, Position ="Junior Software Developer"} ,
                new Employee { id="6",  FirstName="Rinah",      LastName="Simon",   Manager="4", Phone="(285) 912-5271", Level=5, hasChildren=false, Position ="Software Developer"},
                new Employee { id="7",  FirstName="Gage",       LastName="Daniels", Manager="4", Phone="(107) 290-6260", Level=5, hasChildren=false, Position ="Software Architect"},
                new Employee { id="8",  FirstName="Priscilla",  LastName="Frank",   Manager="1", Phone="(278) 927-2684", Level=2, hasChildren=true , Position ="Chief Product Officer"} ,
                new Employee { id="9",  FirstName="Ursula",     LastName="Holmes",  Manager="8", Phone="(302) 760-2034", Level=3, hasChildren=false, Position ="EVP, Product Strategy"} ,
                new Employee { id="10", FirstName="Melvin",     LastName="Carrillo",Manager="8", Phone="(348) 933-5167", Level=3, hasChildren=true,  Position ="Director, Developer Relations" } ,
                new Employee { id="11", FirstName="Martha",     LastName="Chavez",  Manager="10",Phone="(860) 754-3464", Level=4, hasChildren=false, Position ="Developer Advocate"} ,
                new Employee { id="12", FirstName="Oren",       LastName="Fox",     Manager="10",Phone="(572) 414-3299", Level=4, hasChildren=false, Position ="Developer Advocate" } ,
                new Employee { id="13", FirstName="Amos",       LastName="Barr",    Manager="10",Phone="(470) 381-3718", Level=4, hasChildren=false,  Position ="Developer Advocate"} 
            };
        }
    }
}